﻿using System;
using System.Collections.Generic;
using GTA;
using GTA.Native;
using GTA.Math;

namespace GTAV_F22Helper
{
    public class F22Helper : Script
    {
        private F22Raptor mainVehicle;
        private CarpetBomb cBomb, cBomb1;

        public F22Helper()
        {
            mainVehicle = null;
            Tick += OnTick;
        }

        private void OnTick(object sender, EventArgs e)
        {
            var player = Game.Player.Character;

            if (mainVehicle != null && !player.IsInVehicle(mainVehicle.Vehicle))
            {
                if (mainVehicle.BombCam != null)
                    mainVehicle.ToggleBombBayView();

                cBomb.DestroyActiveBombs();
                cBomb1.DestroyActiveSounds();
                mainVehicle = default(F22Raptor);
            }

            if (player.IsInVehicle() && player.CurrentVehicle.Model == VehicleHash.Lazer)
            {
                if ((mainVehicle == null || mainVehicle.Handle != player.CurrentVehicle.Handle))
                {
                    mainVehicle = new F22Raptor(player.CurrentVehicle);
                    cBomb = new CarpetBomb(mainVehicle.Vehicle, new Vector3(-0.6f, 0, 0));
                    cBomb1 = new CarpetBomb(mainVehicle.Vehicle, new Vector3(0.6f, 0, 0));
                }

                else if (mainVehicle.Vehicle.IsDriveable)
                {
                    cBomb.Update();
                    cBomb1.Update();
                    mainVehicle.Update();

                    Control ctlToggleDoor, ctlToggleView, ctlAttack;

                    if (Function.Call<bool>(Hash._GET_LAST_INPUT_METHOD, 2))
                    {
                        ctlToggleDoor = Control.SelectWeaponMelee;
                        ctlToggleView = Control.SelectWeaponUnarmed;
                        ctlAttack = Control.VehicleFlyAttack2;
                    }

                    else
                    {
                        ctlToggleDoor = Control.ScriptRS;
                        ctlToggleView = Control.ScriptPadRight;
                        ctlAttack = Control.ScriptRDown;
                    }

                    if (Game.IsControlJustReleased(0, ctlToggleDoor))
                    {
                        mainVehicle.ToggleBombBay();
                    }

                    if (Game.IsControlJustPressed(0, Control.SelectWeaponShotgun))
                    {
                        mainVehicle.ToggleMissileState();
                    }

                    if (Game.IsControlJustPressed(0, Control.SelectWeaponHeavy))
                    {
                        mainVehicle.ToggleMGState();
                    }

                    if (Game.IsControlJustPressed(0, ctlToggleView))
                    {
                        mainVehicle.ToggleBombBayView();
                    }

                    if (Game.IsControlJustPressed(0, ctlAttack) && mainVehicle.BombCam != null)
                    {
                        cBomb.StartBombingSequence();
                        Wait(150);
                        cBomb1.StartBombingSequence();
                    }

                    if (Game.IsControlPressed(0, ctlAttack) &&
                        mainVehicle.BombCam == null &&
                        Scripts.GetPedVehicleWeapon(player) == 3800181289)
                    {
                        mainVehicle.SetMGState(true);
                    }

                    if (Game.IsControlJustReleased(0, ctlAttack) &&
                        mainVehicle.BombCam == null &&
                       Scripts.GetPedVehicleWeapon(player) == 3800181289)
                    {
                        mainVehicle.SetMGState(false);
                    }
                }
            }
        }

        protected override void Dispose(bool A_0)
        {
            World.RenderingCamera = null;
            Function.Call(Hash.DISPLAY_RADAR, true);
            Function.Call(Hash.DISPLAY_HUD, true);
            Function.Call(Hash.DESTROY_ALL_CAMS, false);

            if (cBomb != null)
            {
                cBomb.DestroyActiveBombs();
                cBomb.DestroyActiveSounds();
            }

            if (cBomb1 != null)
            {
                cBomb1.DestroyActiveBombs();
                cBomb1.DestroyActiveSounds();
            }

            base.Dispose(A_0);
        }
    }


   
}
